
// Copyright (c) 2007 Ein O'Callaghan
//
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt

#pragma once

#define WMU_LOG_UINT_GUID L"LOG_UINT_{6F8B1B93-7096-4a24-8AE5-D1F1DF5E4AC7}"
extern unsigned WMU_LOG_UINT;

#ifdef WNDTRACKER_EXPORTS
#define WNDTRACKER_API __declspec(dllexport)
#else
#define WNDTRACKER_API __declspec(dllimport)
#endif

namespace ghost_tracker
{
	WNDTRACKER_API void set_controler_hwnd(HWND controler);
	WNDTRACKER_API HHOOK install_tracker_hook(DWORD target_thread);
	WNDTRACKER_API HHOOK install_ghost();
	WNDTRACKER_API void uninstall_ghost();
	WNDTRACKER_API bool& faded_out();
	WNDTRACKER_API HWND get_GHOST_hwnd();
	WNDTRACKER_API bool ghost_installed();
	WNDTRACKER_API bool start_ghost();
	WNDTRACKER_API bool stop_ghost();
	WNDTRACKER_API bool uninstall_hook();

	namespace settings
	{

	extern WNDTRACKER_API double fade_in_alpha;
	extern WNDTRACKER_API double fade_out_alpha;
	extern WNDTRACKER_API double fade_alpha;

	extern WNDTRACKER_API unsigned steps;
	extern WNDTRACKER_API unsigned fade_in_time;
	extern WNDTRACKER_API unsigned fade_out_time;

	}
}
