
// Copyright (c) 2007 Ein O'Callaghan
//
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt

#pragma once

#define WMU_LOG_UINT_GUID L"LOG_UINT_{6F8B1B93-7096-4a24-8AE5-D1F1DF5E4AC7}"
extern unsigned WMU_LOG_UINT;

class PropertiesOptions :
    public CPropertyPageImpl<PropertiesOptions>,
    public CWinDataExchange<PropertiesOptions>
{
	typedef PropertiesOptions thisClass;
	typedef CPropertyPageImpl<PropertiesOptions> pageClass;

public:
    enum { IDD = IDD_DEBUG };

	PropertiesOptions()
	{}
	~PropertiesOptions()
	{}

private:
    BEGIN_MSG_MAP_EX(thisClass)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_CLOSE(OnClose)
		COMMAND_ID_HANDLER_EX(ID_INSTALL, OnInstall)
		COMMAND_ID_HANDLER_EX(ID_UNINSTALL, OnUninstall)
		COMMAND_ID_HANDLER_EX(ID_ENABLE, OnEnable)
		COMMAND_ID_HANDLER_EX(ID_DISABLE, OnDisable)
//		COMMAND_ID_HANDLER_EX(ID_TEST, OnTest)

		MESSAGE_HANDLER(WMU_LOG_UINT, OnLogUint)
     	CHAIN_MSG_MAP(pageClass)
    END_MSG_MAP()

    BEGIN_DDX_MAP(thisClass)
    END_DDX_MAP()

    BOOL OnInitDialog(HWND hwndFocus, LPARAM lParam);
    void OnClose();
    int OnApply();

	void OnInstall(UINT, int, HWND);
	void OnUninstall(UINT, int, HWND);
	void OnEnable(UINT, int, HWND);
	void OnDisable(UINT, int, HWND);
//	void OnTest(UINT, int, HWND);

    LRESULT OnLogUint(UINT, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

private:
	CListBox log_list_;
	HWINEVENTHOOK g_hook;

	HWND target_hwnd_;
	DWORD target_thread_id_;
	DWORD target_process_id_;

};

class PropertiesSettings :
    public CPropertyPageImpl<PropertiesSettings>,
    public CWinDataExchange<PropertiesSettings>
{
	typedef PropertiesSettings thisClass;
	typedef CPropertyPageImpl<thisClass> pageClass;

public:
    enum { IDD = IDD_SETTING };

	PropertiesSettings(wstring description) :
		description_(description)
	{}
	~PropertiesSettings()
	{}

private:
    BEGIN_MSG_MAP_EX(thisClass)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_CLOSE(OnClose)
		COMMAND_ID_HANDLER_EX(ID_START, OnStart)
		COMMAND_ID_HANDLER_EX(ID_STOP, OnStop)

//		MESSAGE_HANDLER(WMU_LOG_UINT, OnLogUint)
     	CHAIN_MSG_MAP(pageClass)
    END_MSG_MAP()

    BEGIN_DDX_MAP(thisClass)
    END_DDX_MAP()

    BOOL OnInitDialog(HWND hwndFocus, LPARAM lParam);
    void OnClose();
    int OnApply();

	void OnStart(UINT, int, HWND);
	void OnStop(UINT, int, HWND);

 //   LRESULT OnLogUint(UINT, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

private:
	CFont font_fixedw_;;
	wstring description_;
};

class PropertyDlg :	public CPropertySheet
{
	typedef PropertyDlg thisClass;

public:
	PropertyDlg(LPCTSTR title = (LPCTSTR)NULL, wstring description = L"", bool debug = false, UINT uStartPage = 0, HWND hWndParent = NULL);
	~PropertyDlg();

private:
	BEGIN_MSG_MAP_EX(thisClass)
		MESSAGE_HANDLER(WM_SHOWWINDOW, OnShowWindow)
		CHAIN_MSG_MAP(CPropertySheet)
    END_MSG_MAP()

    LRESULT OnShowWindow(UINT, WPARAM wParam, LPARAM, BOOL& bHandled)
    {
        if (wParam == TRUE) Center();

        bHandled = FALSE;
        return 0;
    }

    void Center()
    {
        if (!m_bCentered)
        {
            CenterWindow();
            m_bCentered = true;
        }
    }
	
	PropertiesOptions propOptions;
	PropertiesSettings propSettings;
    bool m_bCentered;
};
